osg::ProxyNode Class Reference

`#include <ProxyNode>`

Inheritance diagram for osg::ProxyNode:

## Public Types

enum | CenterMode { USE_BOUNDING_SPHERE_CENTER , USER_DEFINED_CENTER , UNION_OF_BOUNDING_SPHERE_AND_USER_DEFINED }
enum | LoadingExternalReferenceMode { LOAD_IMMEDIATELY , DEFER_LOADING_TO_DATABASE_PAGER , NO_AUTOMATIC_LOADING }
typedef osg::BoundingSphere::vec_type | vec_type
typedef osg::BoundingSphere::value_type | value_type
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| ProxyNode ()
| ProxyNode (const ProxyNode &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, ProxyNode)
virtual void | traverse (NodeVisitor &nv)
virtual bool | addChild (Node *child)
virtual bool | addChild (Node *child, const std::string &filename)
template<class T>
bool | addChild (const ref_ptr< T > &child, const std::string &filename)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
void | setDatabaseOptions (osg::Referenced *options)
osg::Referenced * | getDatabaseOptions ()
const osg::Referenced * | getDatabaseOptions () const
void | setDatabasePath (const std::string &path)
const std::string & | getDatabasePath () const
void | setFileName (unsigned int childNo, const std::string &filename)
const std::string & | getFileName (unsigned int childNo) const
unsigned int | getNumFileNames () const
osg::ref_ptr< osg::Referenced > & | getDatabaseRequest (unsigned int childNo)
const osg::ref_ptr< osg::Referenced > & | getDatabaseRequest (unsigned int childNo) const
void | setCenterMode (CenterMode mode)
CenterMode | getCenterMode () const
void | setLoadingExternalReferenceMode (LoadingExternalReferenceMode mode)
LoadingExternalReferenceMode | getLoadingExternalReferenceMode () const
void | setCenter (const vec_type &center)
const vec_type & | getCenter () const
void | setRadius (value_type radius)
value_type | getRadius () const
virtual BoundingSphere | computeBound () const
template<class T>
bool | addChild (const ref_ptr< T > &child)
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

typedef std::pair< std::string, osg::ref_ptr< osg::Referenced > > | FileNameDatabaseRequestPair
typedef std::vector< FileNameDatabaseRequestPair > | FileNameDatabaseRequestList

## Protected Member Functions

virtual | ~ProxyNode ()
void | expandFileNameListTo (unsigned int pos)
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

FileNameDatabaseRequestList | _filenameList
ref_ptr< Referenced > | _databaseOptions
std::string | _databasePath
LoadingExternalReferenceMode | _loadingExtReference
CenterMode | _centerMode
vec_type | _userDefinedCenter
value_type | _radius
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

ProxyNode.

## Member Typedef Documentation

## FileNameDatabaseRequestList

typedef std::vector<FileNameDatabaseRequestPair> osg::ProxyNode::FileNameDatabaseRequestList

protected

## FileNameDatabaseRequestPair

typedef std::pair< std::string, osg::ref_ptr<osg::Referenced> > osg::ProxyNode::FileNameDatabaseRequestPair

protected

## value_type

typedef osg::BoundingSphere::value_type osg::ProxyNode::value_type

## vec_type

typedef osg::BoundingSphere::vec_type osg::ProxyNode::vec_type

## Member Enumeration Documentation

## CenterMode

enum osg::ProxyNode::CenterMode

Modes which control how the center of object should be determined when computing which child is active.

Enumerator
USE_BOUNDING_SPHERE_CENTER |
USER_DEFINED_CENTER |
UNION_OF_BOUNDING_SPHERE_AND_USER_DEFINED |

## LoadingExternalReferenceMode

enum osg::ProxyNode::LoadingExternalReferenceMode

Modes which control how the proxynode external reference are loaded.

Enumerator
LOAD_IMMEDIATELY |
DEFER_LOADING_TO_DATABASE_PAGER |
NO_AUTOMATIC_LOADING |

## Constructor & Destructor Documentation

## ProxyNode() [1/2]

osg::ProxyNode::ProxyNode | ( |  | ) |

Referenced by META_Node(), and ProxyNode().

## ProxyNode() [2/2]

osg::ProxyNode::ProxyNode | ( | const ProxyNode & | ,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References ProxyNode(), and osg::CopyOp::SHALLOW_COPY.

## ~ProxyNode()

virtual osg::ProxyNode::~ProxyNode | ( |  | ) |

inline protected virtual

## Member Function Documentation

## addChild() [1/4]

template<class T>

bool osg::Group::addChild | ( | const ref_ptr< T > & | child | ) |

inline

## addChild() [2/4]

template<class T>

bool osg::ProxyNode::addChild | ( | const ref_ptr< T > & | child,
|  | const std::string & | filename )

inline

References addChild(), and osg::ref_ptr< T >::get().

Referenced by addChild().

## addChild() [3/4]

virtual bool osg::ProxyNode::addChild | ( | Node * | child | ) |

virtual

Add Node to Group. If node is not NULL then increment its reference count, add it to the child list and dirty the bounding sphere to force it to recompute on next getBound() and return true for success. Otherwise return false. Scene nodes can't be added as child nodes.

Reimplemented from osg::Group.

## addChild() [4/4]

virtual bool osg::ProxyNode::addChild | ( | Node * | child,
|  | const std::string & | filename )

virtual

## computeBound()

virtual BoundingSphere osg::ProxyNode::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::Group.

## expandFileNameListTo()

void osg::ProxyNode::expandFileNameListTo | ( | unsigned int | pos | ) |

protected

Referenced by setFileName().

## getCenter()

const vec_type & osg::ProxyNode::getCenter | ( |  | ) | const

inline

Return the ProxyNode center point.

References _centerMode, _userDefinedCenter, osg::Node::getBound(), UNION_OF_BOUNDING_SPHERE_AND_USER_DEFINED, and USER_DEFINED_CENTER.

## getCenterMode()

CenterMode osg::ProxyNode::getCenterMode | ( |  | ) | const

inline

Get how the center of object should be determined when computing which child is active.

References _centerMode.

## getDatabaseOptions() [1/2]

osg::Referenced * osg::ProxyNode::getDatabaseOptions | ( |  | ) |

inline

Get the optional database osgDB::Options object used when loading children.

References _databaseOptions.

## getDatabaseOptions() [2/2]

const osg::Referenced * osg::ProxyNode::getDatabaseOptions | ( |  | ) | const

inline

Get the optional database osgDB::Options object used when loading children.

References _databaseOptions.

## getDatabasePath()

const std::string & osg::ProxyNode::getDatabasePath | ( |  | ) | const

inline

Get the database path used to prepend to children's filenames.

References _databasePath.

## getDatabaseRequest() [1/2]

osg::ref_ptr< osg::Referenced > & osg::ProxyNode::getDatabaseRequest | ( | unsigned int | childNo | ) |

inline

Return the DatabaseRequest object used by the DatabasePager to keep track of file load requests being carried out on behalf of the DatabasePager. Note, in normal OSG usage you should not set this value yourself, as this will be managed by the osgDB::DatabasePager.

References _filenameList.

## getDatabaseRequest() [2/2]

const osg::ref_ptr< osg::Referenced > & osg::ProxyNode::getDatabaseRequest | ( | unsigned int | childNo | ) | const

inline

Return the const DatabaseRequest object.

References _filenameList.

## getFileName()

const std::string & osg::ProxyNode::getFileName | ( | unsigned int | childNo | ) | const

inline

References _filenameList.

## getLoadingExternalReferenceMode()

LoadingExternalReferenceMode osg::ProxyNode::getLoadingExternalReferenceMode | ( |  | ) | const

inline

Get the loading mode.

References _loadingExtReference.

## getNumFileNames()

unsigned int osg::ProxyNode::getNumFileNames | ( |  | ) | const

inline

References _filenameList.

## getRadius()

value_type osg::ProxyNode::getRadius | ( |  | ) | const

inline

Get the object-space radius of the volume enclosed by the ProxyNode.

References _radius.

## META_Node()

osg::ProxyNode::META_Node | ( | osg | ,
|  | ProxyNode | )

References ProxyNode().

## removeChildren()

virtual bool osg::ProxyNode::removeChildren | ( | unsigned int | pos,
|  | unsigned int | numChildrenToRemove )

virtual

Remove children from Group. Note, must be override by subclasses of Group which add per child attributes.

Reimplemented from osg::Group.

## setCenter()

void osg::ProxyNode::setCenter | ( | const vec_type & | center | ) |

inline

Sets the object-space point which defines the center of the osg::ProxyNode. Center is affected by any transforms in the hierarchy above the osg::ProxyNode.

References _centerMode, _userDefinedCenter, UNION_OF_BOUNDING_SPHERE_AND_USER_DEFINED, and USER_DEFINED_CENTER.

## setCenterMode()

void osg::ProxyNode::setCenterMode | ( | CenterMode | mode | ) |

inline

Set how the center of object should be determined when computing which child is active.

References _centerMode.

## setDatabaseOptions()

void osg::ProxyNode::setDatabaseOptions | ( | osg::Referenced * | options | ) |

inline

Set the optional database osgDB::Options object to use when loading children.

References _databaseOptions.

## setDatabasePath()

void osg::ProxyNode::setDatabasePath | ( | const std::string & | path | ) |

Set the database path to prepend to children's filenames.

## setFileName()

void osg::ProxyNode::setFileName | ( | unsigned int | childNo,
|  | const std::string & | filename )

inline

References _filenameList, and expandFileNameListTo().

## setLoadingExternalReferenceMode()

void osg::ProxyNode::setLoadingExternalReferenceMode | ( | LoadingExternalReferenceMode | mode | ) |

inline

Set how the child loading is done.

References _loadingExtReference.

## setRadius()

void osg::ProxyNode::setRadius | ( | value_type | radius | ) |

inline

Set the object-space reference radius of the volume enclosed by the ProxyNode. Used to determine the bounding sphere of the ProxyNode in the absence of any children.

References _radius.

## traverse()

virtual void osg::ProxyNode::traverse | ( | NodeVisitor & |  | ) |

virtual

Traverse downwards : calls children's accept method with NodeVisitor.

Reimplemented from osg::Group.

References osg::Group::addChild().

## Member Data Documentation

## _centerMode

CenterMode osg::ProxyNode::_centerMode

protected

Referenced by getCenter(), getCenterMode(), setCenter(), and setCenterMode().

## _databaseOptions

ref_ptr<Referenced> osg::ProxyNode::_databaseOptions

protected

Referenced by getDatabaseOptions(), getDatabaseOptions(), and setDatabaseOptions().

## _databasePath

std::string osg::ProxyNode::_databasePath

protected

Referenced by getDatabasePath().

## _filenameList

FileNameDatabaseRequestList osg::ProxyNode::_filenameList

protected

Referenced by getDatabaseRequest(), getDatabaseRequest(), getFileName(), getNumFileNames(), and setFileName().

## _loadingExtReference

LoadingExternalReferenceMode osg::ProxyNode::_loadingExtReference

protected

Referenced by getLoadingExternalReferenceMode(), and setLoadingExternalReferenceMode().

## _radius

value_type osg::ProxyNode::_radius

protected

Referenced by getRadius(), and setRadius().

## _userDefinedCenter

vec_type osg::ProxyNode::_userDefinedCenter

protected

Referenced by getCenter(), and setCenter().

The documentation for this class was generated from the following file:

- ProxyNode